; The Best Damn Sprite Routine Period (Mask Version)
; 
; AUTHOR: Sean McLaughlin (sigma_zk@yahoo.com)
;
; DESCRIPTION:
;	Masks a sprite to PlotSScreen with clipping.
;
; INPUT:
;	D	Abscissa
;	E	Ordinate
;	HL	Pointer to start of sprite data:
;		number of rows; sprite row 1, mask row 1; sprite row 2, mask row 2; et cetera.
; DESTROYS:
;	AF BC DE HL IX
;	Interrupts are disabled
;
.MODULE _TBDSRP_M
#define	M_PIXEL_SHIFT	.DB $CB,$31,$17,$29	; SLL C\  RLA\  ADD HL,HL
ClipSprite_MASK:
	LD	B,(HL)
	LD	A,E
	CP	$80
	JR	C,_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	SLA	C
	ADD	HL,BC
	LD	E,B
	LD	B,A
_PosY:
	CP	64
	RET	NC
_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,_DoHoriz
	SUB	B
	CPL
	LD	B,A
_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,_PosX
	CP	-7
	RET	C
	LD	IX,_ClipLeft
	JR	_Patch
_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,_ClipRight
	JR	C,_DoSprite
_Patch:
	LD	(IX),0
_DoSprite:
	DI
	INC	HL
	LD	(_save),SP
	LD	SP,HL
	SLA	E
	SLA	E
	LD	L,E
	LD	H,0
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,_Pos
	DEC	D
_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE

	AND	7
	JR	Z,_Aligned
	DEC	A
	ADD	A,A
	ADD	A,A
	LD	(_Jump),A

_Loop:
	POP	DE
	XOR	A
	LD	C,D
	LD	D,A
	DEC	A
	EX	DE,HL
_Jump	=$+1
	JR	$
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	EX	DE,HL
	AND	(HL)
	XOR	D
_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	AND	(HL)
	XOR	E
_ClipRight:
	LD	(HL),A
	LD	DE,11
	ADD	HL,DE
	DJNZ	_Loop
	LD	(IX),$77
_Done:
_save	=$+1
	LD	SP,0
	RET

_Aligned:
	LD	DE,12
	LD	A,B
_ALoop:
	POP	BC
	EX	AF,AF'
	LD	A,(HL)
	AND	B
	XOR	C
	LD	(HL),A
	ADD	HL,DE
	EX	AF,AF'
	DEC	A
	JP	NZ,_ALoop
	JP	_Done
